blob: 7df53397eb415a7cfba76bd4ebe0d1293192d895 [file] [log] [blame]
Denys Vlasenko10c01a72016-12-23 13:39:22 +01001#!/bin/sh
2# This script expects that the tree was built with the desired .config:
3# in particular, it expects that include/applets.h is generated already.
4#
5# The script will try to rebuild each enabled applet in isolation.
6# All other options which chose general bbox config, applet features, etc,
7# are not modified for the builds.
8
9makeopts="-j9"
10
11# The list of all applet config symbols
12test -f include/applets.h || { echo "No include/applets.h file"; exit 1; }
13apps="`
14grep ^IF_ include/applets.h \
Denys Vlasenko82d1c1f2017-12-31 17:30:02 +010015| grep -v '^IF_FEATURE_' \
Denys Vlasenko10c01a72016-12-23 13:39:22 +010016| sed 's/IF_\([A-Z0-9._-]*\)(.*/\1/' \
Denys Vlasenko82d1c1f2017-12-31 17:30:02 +010017| grep -v '^BUSYBOX$' \
Denys Vlasenko10c01a72016-12-23 13:39:22 +010018| sort | uniq
19`"
20
21# Take existing config
22test -f .config || { echo "No .config file"; exit 1; }
23cfg="`cat .config`"
24
25# Make a config with all applet symbols off
26allno="$cfg"
27for app in $apps; do
28 allno="`echo "$allno" | sed "s/^CONFIG_${app}=y\$/# CONFIG_${app} is not set/"`"
29done
Denys Vlasenko52c21052018-12-06 14:10:10 +010030# remove "busybox" as well
31allno="`echo "$allno" | sed "s/^CONFIG_BUSYBOX=y\$/# CONFIG_BUSYBOX is not set/"`"
Denys Vlasenkob02f8ca2020-06-24 16:36:44 +020032# disable any CONFIG_script_DEPENDENCIES as well
33allno="`echo "$allno" | sed "s/^\(CONFIG_.*_DEPENDENCIES\)=y\$/# \1 is not set/"`"
Denys Vlasenko0b883582016-12-23 16:49:07 +010034#echo "$allno" >.config_allno
Denys Vlasenko10c01a72016-12-23 13:39:22 +010035
Denys Vlasenkoe7b54d02017-01-09 16:31:21 +010036trap 'test -f .config.SV && mv .config.SV .config && touch .config' EXIT
37
Denys Vlasenkob8935d02017-01-15 20:16:27 +010038
Denys Vlasenko10c01a72016-12-23 13:39:22 +010039# Turn on each applet individually and build single-applet executable
Denys Vlasenkob8935d02017-01-15 20:16:27 +010040# (give config names on command line to build only those)
41test $# = 0 && set -- $apps
Denys Vlasenko10c01a72016-12-23 13:39:22 +010042fail=0
Denys Vlasenkob8935d02017-01-15 20:16:27 +010043for app; do
Denys Vlasenko10c01a72016-12-23 13:39:22 +010044 # Only if it was indeed originally enabled...
45 { echo "$cfg" | grep -q "^CONFIG_${app}=y\$"; } || continue
46
47 echo "Making ${app}..."
48 mv .config .config.SV
49 echo "CONFIG_${app}=y" >.config
50 echo "$allno" | sed "/^# CONFIG_${app} is not set\$/d" >>.config
Denys Vlasenko0b883582016-12-23 16:49:07 +010051
Denys Vlasenko7d5c8812016-12-23 19:42:53 +010052 if test x"${app}" != x"SH_IS_ASH" && test x"${app}" != x"SH_IS_HUSH"; then
53 # $allno has all choices for "sh" aliasing set to off.
Denys Vlasenko0b883582016-12-23 16:49:07 +010054 # "sh" aliasing defaults to "ash", not none.
55 # without this fix, "make oldconfig" sets it wrong,
Denys Vlasenko7d5c8812016-12-23 19:42:53 +010056 # resulting in NUM_APPLETS = 2 (the second applet is "sh")
Denys Vlasenko0b883582016-12-23 16:49:07 +010057 sed '/CONFIG_SH_IS_NONE/d' -i .config
58 echo "CONFIG_SH_IS_NONE=y" >>.config
59 fi
60
Denys Vlasenko10c01a72016-12-23 13:39:22 +010061 if ! yes '' | make oldconfig >busybox_make_${app}.log 2>&1; then
Kang-Che Sunged2b9222017-07-15 11:38:58 +080062 fail=$((fail+1))
Denys Vlasenko10c01a72016-12-23 13:39:22 +010063 echo "Config error for ${app}"
64 mv .config busybox_config_${app}
Denys Vlasenko7d5c8812016-12-23 19:42:53 +010065 elif ! make $makeopts >>busybox_make_${app}.log 2>&1; then
Kang-Che Sunged2b9222017-07-15 11:38:58 +080066 fail=$((fail+1))
Denys Vlasenkoe7b54d02017-01-09 16:31:21 +010067 grep -i -e error: -e warning: busybox_make_${app}.log
Denys Vlasenko10c01a72016-12-23 13:39:22 +010068 echo "Build error for ${app}"
69 mv .config busybox_config_${app}
Denys Vlasenkoa1cd0d92016-12-23 15:12:27 +010070 elif ! grep -q '^#define NUM_APPLETS 1$' include/NUM_APPLETS.h; then
Denys Vlasenkoe7b54d02017-01-09 16:31:21 +010071 grep -i -e error: -e warning: busybox_make_${app}.log
Denys Vlasenkoa1cd0d92016-12-23 15:12:27 +010072 mv busybox busybox_${app}
Kang-Che Sunged2b9222017-07-15 11:38:58 +080073 fail=$((fail+1))
Denys Vlasenkoa1cd0d92016-12-23 15:12:27 +010074 echo "NUM_APPLETS != 1 for ${app}: `cat include/NUM_APPLETS.h`"
75 mv .config busybox_config_${app}
Denys Vlasenko10c01a72016-12-23 13:39:22 +010076 else
Denys Vlasenko8b710ef2018-12-30 20:07:54 +010077 if grep -q 'use larger COMMON_BUFSIZE' busybox_make_${app}.log; then
78 # FEATURE_USE_BSS_TAIL=y is selected, and build system
79 # recommends rebuilding. Do so, and print some
80 # debug info to see whether it works right:
81 tail -n1 busybox_make_${app}.log
82 nm busybox_unstripped | grep ' _end'
83 make >/dev/null 2>&1
84 nm busybox_unstripped | grep ' _end'
85 grep ^bb_common_bufsiz1 busybox_unstripped.map
86 fi
Denys Vlasenkoe7b54d02017-01-09 16:31:21 +010087 grep -i -e error: -e warning: busybox_make_${app}.log \
88 || rm busybox_make_${app}.log
Denys Vlasenko10c01a72016-12-23 13:39:22 +010089 mv busybox busybox_${app}
Denys Vlasenkoe7b54d02017-01-09 16:31:21 +010090 #mv .config busybox_config_${app}
Denys Vlasenko10c01a72016-12-23 13:39:22 +010091 fi
92 mv .config.SV .config
93 #exit
94done
Denys Vlasenkoa1cd0d92016-12-23 15:12:27 +010095touch .config # or else next "make" can be confused
Denys Vlasenko10c01a72016-12-23 13:39:22 +010096echo "Failures: $fail"
97test $fail = 0 # set exitcode